net.sf.saxon.om

## Interface AtomicSequence

- All Superinterfaces:
    GroundedValue, Sequence
  All Known Implementing Classes:
    AnyURIValue, AtomicArray, AtomicValue, Base64BinaryValue, BigIntegerValue, BooleanValue, CalendarValue, DateTimeValue, DateValue, DayTimeDurationValue, DecimalValue, DoubleValue, DurationValue, EmptyAtomicSequence, FloatValue, GDateValue, GDayValue, GMonthDayValue, GMonthValue, GYearMonthValue, GYearValue, HexBinaryValue, Int64Value, IntegerRange, IntegerValue, NotationValue, NumericValue, QNameValue, QualifiedNameValue, StringValue, TimeValue, UntypedAtomicValue, YearMonthDurationValue

      public interface AtomicSequence
      extends Sequence, GroundedValue

  Interface representing a sequence of atomic values. This is often used to represent the typed value of a node. In most cases the typed value of a node is a single atomic value, so the class AtomicValue implements this interface.

  An AtomicSequence is always represented as a GroundedValue: that is, the entire sequence is in memory, making operations such as `itemAt(int)` and `getLength()` possible.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `CharSequence` | `getCanonicalLexicalRepresentation()` Get the canonical lexical representation as defined in XML Schema.
    `int` | `getLength()` Get the size of the value (the number of items)
    `Comparable` | `getSchemaComparable()` Get a Comparable value that implements the XML Schema ordering comparison semantics for this value.
    `String` | `getStringValue()` Get the string value of this sequence.
    `CharSequence` | `getStringValueCS()` Get the string value of this sequence.
    `AtomicValue` | `head()` Get the first item in the sequence.
    `AtomicValue` | `itemAt(int n)` Get the n'th item in the value, counting from 0
    `SequenceIterator<? extends AtomicValue>` | `iterate()` Get an iterator performance characteristics, though all should exhibit the same behaviour.over all the items in the sequence

    - ### Methods inherited from interface net.sf.saxon.om.GroundedValue

      `effectiveBooleanValue, reduce, subsequence`

- - ### Method Detail

    - #### head

          AtomicValue head()

      Description copied from interface: `Sequence`
      Get the first item in the sequence.
      Specified by:
        `head` in interface `Sequence`
      Returns:
        the first item in the sequence if there is one, or null if the sequence is empty

    - #### iterate

          SequenceIterator<? extends AtomicValue> iterate()

      Description copied from interface: `Sequence`
      Get an iterator performance characteristics, though all should exhibit the same behaviour.over all the items in the sequence
      Specified by:
        `iterate` in interface `Sequence`
      Returns:
        an iterator over all the items

    - #### itemAt

          AtomicValue itemAt(int n)

      Description copied from interface: `GroundedValue`
      Get the n'th item in the value, counting from 0
      Specified by:
        `itemAt` in interface `GroundedValue`
      Parameters:
        `n` - the index of the required item, with 0 representing the first item in the sequence
      Returns:
        the n'th item if it exists, or null otherwise

    - #### getLength

          int getLength()

      Description copied from interface: `GroundedValue`
      Get the size of the value (the number of items)
      Specified by:
        `getLength` in interface `GroundedValue`
      Returns:
        the number of items in the sequence

    - #### getCanonicalLexicalRepresentation

          CharSequence getCanonicalLexicalRepresentation()

      Get the canonical lexical representation as defined in XML Schema. This is not always the same as the result of casting to a string according to the XPath rules.
      Returns:
        the canonical lexical representation if defined in XML Schema; otherwise, the result of casting to string according to the XPath 2.0 rules

    - #### getSchemaComparable

          Comparable getSchemaComparable()

      Get a Comparable value that implements the XML Schema ordering comparison semantics for this value. The default implementation is written to compare sequences of atomic values. This method is overridden for AtomicValue and its subclasses.

      In the case of data types that are partially ordered, the returned Comparable extends the standard semantics of the compareTo() method by returning the value `SequenceTool.INDETERMINATE_ORDERING` when there is no defined order relationship between two given values.

      Returns:
        a Comparable that follows XML Schema comparison rules

    - #### getStringValueCS

          CharSequence getStringValueCS()

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValueCS` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

    - #### getStringValue

          String getStringValue()

      Description copied from interface: `GroundedValue`
      Get the string value of this sequence. The string value of an item is the result of applying the string() function. The string value of a sequence is the space-separated result of applying the string-join() function using a single space as the separator
      Specified by:
        `getStringValue` in interface `GroundedValue`
      Returns:
        the string value of the sequence.

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.